#include <18F4620.h>
#fuses INTRC_IO, NOWDT,NOPROTECT,NOLVP
#use delay(clock=32M)
#use rs232(baud=115200, xmit=PIN_C6, rcv=PIN_C7) 
#define GLCD_WIDTH   128
#define FAST_GLCD

#define dur    0
#define asagi  1
#define saga   2
#define sola   3
#define yukari 4

#define pasif          0
#define kovala         1



#define soltus 253
#define sagtus 239
#define alttus 247
#define usttus 254
#define orttus 251



//#define TONE_PIN  PIN_C2
#define SPEECH_SOL PIN_C2
#define SPEECH_SAG PIN_A3

#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1   // Chip Selection 2
#define GLCD_DI      PIN_A2   // Data or Instruction input
#define GLCD_RW      PIN_A4   // Read/Write
#define GLCD_E       PIN_A5   // Enable

#include <HDM64GS12.c>
#include <graphics.c>


   
#include "splashscreen.h"

#include "ding_converted.c"


const int submarine[]= { 
0x90,0xF0,0x60,0x60,0xF0,0xF0,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xFE,0xFF,0xFF,0xFF,0xFF,0xD8,0xF8,0xF8,0xD8,0xF8,0xF8,0x70

};

int gidisyonu;  

// Maze size 12 x 25   koordinatlar 0-11 0-24 arasi degisiyor
// Maze merkezi        6 - 12

char maze[12][26]="        _| |_            ",
                  "        \___/            ",
                  "-------------------------",                  
                  "                         ",
                  "                         ",
                  "                         ",
                  "        o                ",
                  "                         ",
                  "                         ",
                  "                         ",
                  "                         ",
                  "XXXXXXXXXXXXXXXXXXXXXXXXX";

typedef struct 
{ 
   int r, c; 
   int x, y; 
   int dir: 2;
   int lives ;
//   int speed;
   int score;
} subveri;
    
subveri nautil;

typedef struct 
{ 
   int r, c; 
   int pixr, pixc; 
   int targetr, targetc;
   int state: 4;
   int dir: 2;
   int active: 1;
//   int speed;
} shipveri;



int oncekitus;

  
//char  skor[] = "00";
//   char  ovir[] = "over"  ;
   
  
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(speech_SOL);
      output_low(speech_SAG);
      delay_ms(1);
      output_low(speech_SOL);
      output_high(speech_SAG);
      delay_ms(1);
   }
} 

void click(int gidisyonu){
      output_high(speech_SOL);
      output_low(speech_SAG);
      delay_us(gidisyonu*5);
      output_low(speech_SOL);
      output_high(speech_SAG);
      delay_us(gidisyonu*5);
}
  
  
void ciuv(int period, int saysur){
int sayper;
int sayac;
sayper = period;
 while((sayper--) != 0)
 {
      for(sayac=1;sayac<saysur;sayac++)
      {
      output_high(speech_SOL);
      output_high(speech_SAG);
      delay_us(sayac);
      delay_us(sayac);
      output_low(speech_SOL);
      output_low(speech_SAG);      
      delay_us(sayac);
      delay_us(sayac);
      }
 }
}  


void ding() 

{ 

int16 i; 
int8 c; 
int8 currentbit; 
int1 prevbit;
int1 bosluk;

enbas:
c = sound_datading[i]; 


for (i=0; i<3968; i++){  //Go through the sound_data array 
c = sound_datading[i]; 
//***********************Read bitwise 
               for (currentbit = 0; currentbit < 8; currentbit++){ 
                  if(  bit_test(c,currentbit)  ){  //If the bit is a 1. 
                     if ( prevbit == 1 ) { output_high(SPEECH_SAG); output_high(SPEECH_SOL);}
                     else { bosluk = input ( SPEECH_SAG ); bosluk = input ( SPEECH_SOL );}
                     prevbit =  1;
                  }else{                                //If the bit is a 0. 
                     if ( prevbit == 0 ) { output_low(SPEECH_SAG); output_low(SPEECH_SOL);}
                     else { bosluk = input ( SPEECH_SAG ); bosluk = input ( SPEECH_SOL ); }
                     prevbit =  0;
                  } 
                  delay_us(21); 
               } 
//**********************/Read bitwise 
}

} 

void splashscreen(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(picmansplash[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}



tusbak(){
int basilantus;
/*output_e (0b101);
printf("\f(%u) ", input_b()); 
output_e (0b110);
printf("(%u) ", input_b());*/
output_e (0b011);
//printf("(%u)", input_b());
basilantus = input_b() | 0b11100000;
//if ( basilantus != 0xFF)   click(0);
if ( oncekitus != basilantus )   { 
  oncekitus = basilantus ;
  //sprintf ( watch , "%u", basilantus);
  return basilantus;
}
else return 0xFF;

}

void denizbas(){
int say;
   for ( say = 0 ; say < 25 ; say++)
   {
            glcd_pixel( say*5,   2*5+3, 1 );
            glcd_pixel( say*5+1, 2*5+2, 1 );
            glcd_pixel( say*5+2, 2*5+1, 1 );
            glcd_pixel( say*5+3, 2*5+2, 1 );
            glcd_pixel( say*5+4, 2*5+3, 1 );
   }
}

void mazebas(){
int row, col;

   for ( row = 0 ; row < 12 ; row++){
      for ( col = 0 ; col < 25 ; col++){
         

         //if ( maze[row][col] == 'x' ) glcd_rect(col*5+1, row*5+1, col*5+5, row*5+5, 0 , 1);   
         if ( maze[row][col] == '-' ) { 
            glcd_pixel( col*5,   row*5+3, 1 );
            glcd_pixel( col*5+1, row*5+2, 1 );
            glcd_pixel( col*5+2, row*5+1, 1 );
            glcd_pixel( col*5+3, row*5+2, 1 );
            glcd_pixel( col*5+4, row*5+3, 1 );
         }
         if ( maze[row][col] == ',' ) {
            glcd_circle(col*5+3, row*5+3,  1, 1, 1);
         }
      }
   }
}
void shipciz( ){

   glcd_line(nautil.x-1, nautil.y, nautil.x+1, nautil.y , 1) ;
   glcd_line(nautil.x+2, nautil.y, nautil.x+2, nautil.y+5 , 1) ;
   glcd_line(nautil.x+2, nautil.y+5, nautil.x+3, nautil.y+5 , 1) ;
   glcd_line(nautil.x+3, nautil.y+5, nautil.x+5, nautil.y+7 , 1) ;

}

void subciz(int xs, int ys)
{

int i, j, k;
int sayac2=0 ;

int width = 24;
int height = 8;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(submarine[sayac2],k)){
               if ( nautil.dir == saga ) glcd_pixel(xs+j-14,ys+i+k,ON); 
               else glcd_pixel(xs-j+14,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}



void main() {


   int tusdeger, donsay; 
   int bembsayac, bembno;
   int bembx[5], bemby[5];
   //int1 bembact[5];

   //int skorsayac;

/*
   int16 yavaslat1, yavaslat2, randrand;
   int32 splashbekle;
   int  sayac, randx=200, randy=200, dotx, doty ;
   int1  soltusbirak = 1, sagtusbirak = 1;
   int1  soltusbirak2 = 1, sagtusbirak2 = 1;
   int1  twoplayer;
*/
   setup_oscillator(OSC_32MHZ | OSC_PLL_ON);
   setup_adc_ports(NO_ANALOGS);
   

   nautil.x = 50 ;
   nautil.y = 30 ;
   bembno = 0;
   bembsayac = 10;
   
   
   printf(" Ozkal's SUBHUNT (%s) (%s )\n\r",__FILENAME__,__DATE__); 
   
   //srand(29);
   
   port_b_pullups( TRUE );
   glcd_init (ON);
   //splashscreen(0,0);
   //glcd_update ();
   //ciuv(1,200);



  

   while(TRUE){
   
   printf("\f%u",bembno);    
   glcd_fillScreen(0);  
   //glcd_rect(0,0,127,63,0,1);
   tusdeger = tusbak();
   if ( tusdeger == orttus ) { 
      bembno++;
      bembx[0]= nautil.x; 
      bemby[0]= nautil.y;
   }
   if ( tusdeger == soltus && nautil.x>9) { nautil.x --; nautil.dir = sola; }
   if ( tusdeger == sagtus && nautil.x<118) { nautil.x ++; nautil.dir = saga; }
   if ( tusdeger == usttus && nautil.y>8) { nautil.y --;  }
   if ( tusdeger == alttus && nautil.y<55) { nautil.y ++;  }
   denizbas();   
   
      if ( bembx[ 0 ]!=0 && bemby[ 0 ] !=0 ) glcd_pixel(bembx[0] , bemby[0],ON);

   
   if ( bembsayac-- == 0 ) {

         if ( bemby[donsay] > 13 ) bemby[donsay]--;      
         else { bembx[donsay]=0; bemby[donsay]=0;}
      bembsayac = 10 ;     
   }
   subciz(nautil.x , nautil.y );
   
   glcd_update ();

//   sprintf(skor,"%u",picman1.score); 

        
   
   }
}
